/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: Exercise.java,v 1.6 2004/05/26 08:05:43 vkaravir Exp $ */

package content.exercises;


/**
 * Common superinterface for all exercises in Matrix test application.
 * Since it is planned that Matrix might someday support several different
 * kinds of exercises (algorithm simulation exercises, multiple choice
 * exercises, etc), this interface does not have many features.
 * <p>
 * It extends the interface <code>java.io.Serializable</code> in order
 * for remote use of exercises (for example through an applet communicating
 * with a server, etc).
 * <p>
 * See the various subinterfaces for more information
 *
 * @author Jussi Nikander
 * @version $Revision: 1.6 $
 *
 */
public interface Exercise extends java.io.Serializable {

    /** Exercise information. */
    public  String getDescription();

    static final long serialVersionUID = -8789383152746056302L;
}
