/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: Heap_BuildHeap.java,v 1.23 2004/05/26 08:05:44 vkaravir Exp $ */

package content.exercises;

import matrix.animation.Animator;
import matrix.simulation.VisualTypeConf;
import matrix.structures.FDT.FDT;
import matrix.structures.memory.Key;
import matrix.util.*;

public class Heap_BuildHeap implements SimulationExerciseModel, ModelAnswerNames,  StyledExercise, ConfigureVisualType {
    ExerHeap bh,bh2;
    String dataString;
    String marker = "Heap_BuildHeap";
    Object [] objects;
    public static final boolean DEBUG = false;

    public Heap_BuildHeap() {
    }


    long seed = 1;;

    /**
     * Get the value of seed.
     * @return value of seed.
     */
    public long getSeed() {
        return seed;
    }

    /**
     * Set the value of seed.
     * @param v  Value to assign to seed.
     */
    public void setSeed(long  v) {
        this.seed = v;
    }



    public FDT[] init() {
        Note.out(this, "Initalizing data structures");
        //t = new Table("KPURSTLMACDX");
        dataString = RandomKey.createNoDuplicateUppercaseRandomKey(new java.util.Random(seed),15);
        objects = new Key[dataString.length()];
        for (int i = 0; i < dataString.length(); i++)
            objects[i] = new Key(""+dataString.charAt(i));

        bh = new ExerHeap(objects);
        FDT[]  s = { bh, bh };
        return s;
    }


    // styled exercise

    public String[] getStructureVisualisations() {
        String[] s = { "array" , "leaf tree"};
        return s;
    }


    public String[] getModelAnswerVisualisations() {
        String[] s = { "leaf tree" };
        return s;
    }


    public FDT[] init(Object o) {
        return init();
    }


    public String[] getStructureNames() {
        String[] s = { "Array Representation of Binary Heap", "Binary Heap" };
        return s;
    }

    public String getDescription() {
        return "";
    }

    public FDT[] solve() {

        bh2 = (ExerHeap)getInitialStructures()[0];
        Animator a = Animator.getActiveAnimator();
        for (int i=objects.length/2; i>=0; i--) {
            a.startOperation();
            bh2.Heapify(i);
            //bh2.insert(t2.getObject(i));
            a.endOperation();
            }
        return new FDT[] { bh2 };
    }



    public FDT[] makeModelAnswer() {
	return solve();
    }



    public FDT[] getInitialStructures() {
        ExerHeap tmp = new ExerHeap(objects);
        return new FDT[] { tmp };
    }

    public FDT[] getSimulatedStructures() {
        return new FDT[] { bh };
    }

    public FDT[] getAnswer() {
        FDT[] s = { bh };
        return s;
    }

    public String[] getModelAnswerNames() {
        String[] s = { "Binary Heap" };
        return s;
    }


    public SimulationExerciseModel getModelAnswer() {
        return this;
    }

    public VisualTypeConf[] conf() {
        VisualTypeConf tabl = new VisualTypeConf();
        tabl.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
        tabl.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
        tabl.enable("matrix.visual.VisualKey", VisualTypeConf.DROP_OPERATION);
        VisualTypeConf tre = new VisualTypeConf();
        tre.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
        tre.enable("matrix.visual.VisualKey", VisualTypeConf.DROP_OPERATION);
        tre.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
        return new VisualTypeConf[] { tabl, tre };
    }


    static final long serialVersionUID = 9123896676872755713L;
}
