/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*$Id: SimulationExerciseSelfAssessment.java,v 1.6 2004/05/26 08:05:46 vkaravir Exp $*/

package content.exercises;


/**
 * This interface contains methods that are required for exercise
 * to self evaluate the answer and give points to it.
 * Using this model, the answer is evaluated at the server, but
 * using the method in user-supplied class.
 *
 * @author Harri Salonen
 * @version 1.0
 */
public interface SimulationExerciseSelfAssessment extends SimulationExerciseModel {
    /**
     * Grades the answer.
     * @return points for each answer.
     */
    public int[] judge();


    /**
     * Gives the maximum points for this exercise.
     * @return maximum points
     */
    public int getMaxPoints();

    /* XXX init(Object) should probably be in SimulationExercise.
     * It is here in order to avoid writing dummy inits for all
     * test exercises that implement SimulationExercise.
     */
    
    
    static final long serialVersionUID = 5123418430520880004L;
}
