/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: Evaluation.java,v 1.9 2004/05/26 08:05:48 vkaravir Exp $ */

package matrix.animation;

import matrix.util.Note;
import matrix.visual.VisualType;

public class Evaluation implements AnimatedOperation {
    VisualType read = null;
    VisualType previousRead = null;

    public Evaluation(VisualType read) {
        this.read = read;
        this.previousRead = VisualType.read;
    }

    public void undo() {
        Note.out(this, "undo");
        VisualType.read = previousRead;
        if (read != null) read.validate();
    }

    public void redo() {
        Note.out(this, "redo");
        VisualType.read = read;
        if (read != null) read.validate();
    }

    public String toString() {
        return "Read " + read;
    }

    static final long serialVersionUID = 1477730183767560417L;
}
