package matrix.structures.CDT.probe;

import matrix.structures.CDT.CDT;
import matrix.structures.FDT.*;
import matrix.structures.FDT.probe.LinkedListImpl;


public class OrderedList extends LinkedListImpl implements CDT {
    
    public OrderedList() {
	super();
    }

    public OrderedList(Object key) {
	super();
	setElement(key);
    }

    /**
     * Returns new (List) node with a given key. 
     *
     * @param key key of new node
     * @return new (List) Node
     */    
    public LinkedList getNewNode(Object key) {
	return new OrderedList(key);
	}


    /**
     * Inserts a new key to the last position of the queue. This insert operation just calls 
     * the enqueue operation.
     *
     * @param key new key
     * @return queue after insertion
     */
    public FDT insert(Object key) {

	String currentStr = "";
	String keyStr = "";

	if (getElement() != null)
	    currentStr = getElement().toString();

	if (key != null) 
	    keyStr = key.toString();


	// last element of list

	if (getNext() == null && keyStr.compareTo(currentStr) > 0) {
	    setNext(new OrderedList(key));	    
	    return this;
	}

	
	else if (keyStr.compareTo(currentStr) > 0) {
	    setNext((OrderedList)((OrderedList)getNext()).insert(key));
	    return this;
	}
	
	else {
	    OrderedList newList = new OrderedList(key);
	    newList.setNext(this);
	    return newList;

	}
	
    }



    /**
     * This method deletes the node containing the given key and all
     * its predecessors from the queue and returns 
     * the first node of queue after deletion.
     *
     * @param o key to be deleted
     * @return returns always the first node of the queue after 
     * deletion.
     */
    public FDT delete(Object o) {
	return null;
    }


    public Object search(Object o) {
	return null;
    }






}
