/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: Vertex.java,v 1.12 2004/05/25 13:28:14 kstalnac Exp $ */

package matrix.structures.FDT;

//import matrix.structures.memory.*;

/** Common interface for all Vertice.
 * This interface defines the methods necessary to iterate through
 * a set of vertices.
 * @see Graph
 *
 * @author Ari Korhonen, Riku Saikkonen
 * @version $Revision: 1.12 $
 */
public interface Vertex extends FDT {

    /**
     * Retuns the successor nodes of this vertes.
     *@return the successor nodes of this vertex.
     */
    public Vertex[] getSuccessors();

    /**
     * Returns the key of this vertex.
     * @return the key
     */
    public Object getElement();

    /**
     * Sets the key of this vertex.
     * @param o the new key
     */
    public void setElement(Object o);


    static final long serialVersionUID = 2663296277736260922L;
}
