/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package matrix.structures.FDT.probe;

import matrix.structures.FDT.*;

/**
 * Simple implementation of UndirectedGraph
 */
public class UndirectedGraphImpl extends DirectedGraphImpl implements UndirectedGraph {

    public UndirectedGraphImpl() {
        super();
    }
    /*
    public void insertEdge(Vertex from, Vertex to) {
        super.insertEdge(from, to);
        super.insertEdge(to, from);
    }
    */

    public VertexImpl getNewVertex(Object o) {
        return new UndirVertex(o);
    }

    public void addVertex(Object o) {
        if(o instanceof UndirVertex)
            super.addVertex(o);
        else if(o instanceof FDT)
            super.addVertex(getNewVertex(((FDT)o).getElement()));
        else
            super.addVertex(getNewVertex(o));
    }

    static final long serialVersionUID = -9109053664470363922L;
}
