/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package matrix.util;

import java.awt.*;
import java.awt.event.*;

/**
 * Dialog with information about matrix
 *
 * @author Petri Tenhunen
 */
public class AboutDialog extends Dialog {
  
  /** Version information */
  public static final String version = "Matrix build 10";
  
  /** 
   * Constructor
   * @param parent Owner frame for this dialog
   */
  public AboutDialog(Frame parent) {
    super(parent, version, true);
    setLayout(new BorderLayout());
    ScrollPane scroll = new ScrollPane();
    TextArea txt = new TextArea("Matrix -- Algorithm Simulation and Algorithm Animation Framework build 10\n"+
 "Copyright (C) 2000-2004 Matrix group\n"+
 "(See the AUTHORS file for more information on the authors.)\n"+
 "\n"+
 "This program is free software; you can redistribute it and/or modify\n"+
 "it under the terms of the GNU General Public License as published by\n"+
 "the Free Software Foundation; either version 2 of the License, or\n"+
 "(at your option) any later version."+
 "\n\n"+
 "This program is distributed in the hope that it will be useful,\n"+
 "but WITHOUT ANY WARRANTY; without even the implied warranty of\n"+
 "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"+
 "GNU General Public License for more details."+
 "\n\n"+
 "You should have received a copy of the GNU General Public License\n"+
 "along with this program; if not, write to the Free Software\n"+
 "Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n"+
 "\n\n"+
 "For more information see http://www.cs.hut.fi/Research/Matrix/\n\n"+
 "Please, send all comments and suggestions to matrix@cs.hut.fi",22,55,
				TextArea.SCROLLBARS_VERTICAL_ONLY);
    txt.setEditable(false);
    add(txt, BorderLayout.CENTER);
    
    Button btn = new Button("OK");
    btn.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	dispose();
      }
    });

    add(btn, BorderLayout.SOUTH);
    
    this.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) { dispose(); }
    });

  }
  
}


