/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: QueryString.java,v 1.9 2004/05/25 13:28:26 kstalnac Exp $ */

package matrix.util;

import java.awt.*;
import java.awt.event.*;

public class QueryString extends Dialog {
        Dialog dial;
        TextField tf;
        Button ok, cancel;
        String txt;
        
        public QueryString(Frame f, String title, String text) {
            super(f, title);
            this.txt = text;
            //Note.out(this, "txt = " + txt);
            this.setLayout(new FlowLayout());
            this.setModal(true);
            tf = new TextField(text, text != null ? text.length()+10 : 20);
	    tf.addKeyListener(new KeyListener() {
		    public void keyPressed(KeyEvent e) {
			if (e.getKeyCode() == KeyEvent.VK_ENTER)
			    ok();
		    }
		    public void keyReleased(KeyEvent e) {}
		    public void keyTyped(KeyEvent e) {}
		});
            ok = new Button("Ok");
            cancel = new Button("Cancel");
            add(tf);
            add(ok);
            add(cancel);
            ok.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) { ok(); }
            });
            cancel.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) { cancel(); }
            }); 
            Menu qmenu = new Menu("Ok");
            MenuItem qmi;
            qmenu.add(qmi = new MenuItem("Ok", new MenuShortcut(KeyEvent.VK_ENTER)));
            qmenu.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) { ok(); }
            });
            // rest
            this.pack();
            this.show();
        }
        
        public void ok() {
            //Note.out(this, "Ok " + txt);
            txt = tf.getText();
            dispose();
        }
        
        public void cancel() {
            //Note.out(this, "Cancel " + txt);
            dispose();
        }
        
        public static String ask(Frame f, String title, String txt) {
            QueryString qs = new QueryString(f, title, txt);
            //Note.out(null, "return " + qs.txt);
            return qs.txt;
        }

    public static String ask(String title, String txt) {
	Frame f = new Frame();
	return ask(f, title, txt);
    }

}
        
