/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: VisualAWTComponent.java,v 1.4 2004/05/26 08:06:06 vkaravir Exp $ */

package matrix.visual;

import java.awt.*;

import matrix.structures.FDT.FDT;
import matrix.structures.memory.Key;

public class VisualAWTComponent extends VisualKey {
    private java.awt.Component awtComponent;

    public VisualAWTComponent(java.awt.Component k) {
	super(new Key(k));
        awtComponent = k;
    }
    
    public FDT getStructure() {
        return key;
    }

    public void doLayout() {
	awtComponent.doLayout();
    }
    
    public Dimension getPreferredSize() { 
	return awtComponent.getPreferredSize();
    }
    
    public void paint(Graphics g) {
        super.paint(g);
	awtComponent.paint(g);
    }
}
