/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: VisualArrow.java,v 1.11 2004/05/25 13:28:34 kstalnac Exp $ */

package matrix.visual;

import java.awt.*;

public class VisualArrow extends VisualComponent {
    VisualReference ref;
    VisualType actualTarget;
    int xd, yd;

    public VisualArrow(VisualReference ref) {
        super(null);
        this.ref = ref;
        this.actualTarget = ref.getTarget();
        matrix.util.Note.out(this, "actual target = " + actualTarget);
    }

    public void setColor(Graphics g) {
        if (color == null) color = g.getColor();
        if (hasRead() || hasFocus())
            g.setColor(Color.red);
        else 
            g.setColor(Color.yellow);   
    }

    // Dummy methods for VisualComponent
    public VisualType getVisualType() { return null; }
    public matrix.structures.FDT.FDT getKey() { return null; }
    public void assign() { }

    /*
    public Rectangle getBounds() {
        Rectangle r = super.getBounds();
        Rectangle targetCoord = ref.getParent().getBounds();
        r.translate(-targetCoord.x,-targetCoord.y);
        return r;
    }
    */
    /*
    public void repaint() {
        matrix.util.Note.out(this, "bounds = " + getBounds());
        matrix.util.Note.out(this, "ref bounds = " + ref.getBounds());
        //setSize(1,1);
        //ref.getSource().repaint();
    }
    */
    public void paint(Graphics g) {
        // do nothing
    }
}
