/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: VisualClassMethod.java,v 1.13 2004/05/26 08:06:07 vkaravir Exp $ */

package matrix.visual;

//import java.util.Vector;
//import java.util.Enumeration;
import java.io.PrintStream;
import java.lang.reflect.Method;

import matrix.structures.memory.Key;
//import matrix.visual.code.*;  [debugger code commented out]
//import testapp.ui.MatrixClassLoader;

/** This component is used to represent the methods of a class.
 * @see VisualClass
 *
 * @author Ari Korhonen
 * @author Panu Silvasti
 * @version $Revision: 1.13 $
 */
public class VisualClassMethod extends VisualKey {
    Method method;
    
    // debug
    public void dump(PrintStream out) {
        super.dump(out);
    }

    // constructor
    public VisualClassMethod(Method m) {
        super(new Key(m.getName()));
        method = m;
    }

    /* [debugger code commented out]
    public void write() {
        Note.out(this, "Call Debugger for " + method);
	Class clazz =  method.getDeclaringClass();
	String className = clazz.getName();
	String sourceFile = null;
	ClassLoader ld = clazz.getClassLoader();
	if (ld instanceof MatrixClassLoader) {
	    sourceFile = ((MatrixClassLoader)ld).fileName(className);
	}
	
	DebuggerClient d = DebuggerClient.getInstance();
	if (d != null) {
	    d.createDebugWindow(-1, className, method.getName());
	} else {
	    Note.err(this, "Cannot get debugger.");
	}
        }
    */
}
