/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: VisualHeadReference.java,v 1.16 2004/05/26 08:06:09 vkaravir Exp $ */

package matrix.visual;

import java.awt.*;

import matrix.structures.FDT.FDT;
import matrix.util.Note;

/* XXX Class used by VisualTree only. Check someday how and why */

public class VisualHeadReference extends VisualReference {

    public VisualHeadReference(VisualComponent t) {
        super(new VisualHead(t), t);
    }
    
    public FDT getStructure() { return null; }
    
    public void doLayout() {
        Rectangle r = to.getBounds();
        if (from != null) {
            ((VisualHead)from).setVisualContainer(getVisualContainer());
            //XXX rotated bounds don't work
            //Note.out(this, r.x+","+r.y+","+r.width+","+r.height);
            from.setBounds(r.x, 0, r.width, r.height);
        } else Note.err(this, "Warning: no visualhead found during do layout.");
        super.doLayout();
    }
    
    public void paint(Graphics g) {
        super.paint(g);
    }
}
