/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: VisualLabel.java,v 1.14 2004/05/26 08:06:10 vkaravir Exp $ */

package matrix.visual;

import java.awt.Font;

import matrix.structures.memory.Key;

public class VisualLabel extends VisualKey {

    public VisualLabel(Key k) {
        super(k);
    }

    /*
    public void setColor(Graphics g) {
        if (getParent() instanceof VisualType)
            ((VisualType)getParent()).setColor(g);
    }
    */
    private Font myFont = null;

    public void doLayout() {
        Font f = super.getFont();
        if (f == null)
            return;

        if (!((myFont != null) &&
              (myFont.getName().equals(f.getName())) &&
              (myFont.getStyle() == f.getStyle()) &&
              (myFont.getSize() == (f.getSize()/2))))
            myFont = new Font(f.getName(), f.getStyle(), f.getSize()/2);
        super.doLayout();
    }

    //private int cnt = 0; XXXX bug somewhere (see Note.err)? XXXX
    /*
    public final Font getFont() {
        //if (cnt++ == 100) Note.err(this, "getFont invoked too often");
        return myFont;
    }
    */
    // Need to be defined because the behaviour of the super.getSemantics()
    // is not what we expect (causes exceptions in case we try to write)
    public static int getSemantics() {
        return semantics;
    }

}
