/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package prototype.ui;

import java.awt.*;

import matrix.uitools.*;
import matrix.uitools.MenuFrame;
import matrix.util.*;
import matrix.util.configuration.MatrixConfiguration;

public class TestFrame extends MenuFrame {


    public TestFrame() {
	super();
    }

    public TestFrame(StructurePanel p) {
	super(p);
    }

    public Frame getNewFrame(StructurePanel p) {
	return new TestFrame(p);
    }

    public Frame getNewFrame() {
	return new TestFrame();
    }

    protected MenuBar createMenuBar() {
	Note.out(this, "Creating menu bar");
	MenuFactory mf = MenuFactory.getInstance();
	return mf.getMenuBar(this);
    }

    
    public static void main(String[] args) {
	System.out.println("Starting TestFrame");
	Note.setOut(true);
	if(args.length > 0 && !(args[0].equals(""))) {
	    //matrix.util.Note.out(null, "Setting conf path");
	    //matrix.visual.RepresentationFactory.setConfPath(args[0]);
	    MatrixConfiguration.setConfPath(args[0]);
	}
	
	if(args.length > 1) {
	    String arg = args[1].toLowerCase();
	    if(arg.equals("t") || arg.equals("true"))
		MatrixConfiguration.setValidatingParser(true);
	}
	Note.out(null, "Getting MatrixConfiguration");
	MatrixConfiguration m = MatrixConfiguration.getInstance();
	Note.out(null, "Creating new TestFrame");
	TestFrame mf = new TestFrame();
	ApplicationAdapter.setApplication(mf.getStructurePanel());
	
    }

}
